#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include "terminal.h"
#include "gdt.h"
#include "idt.h"
#include "timer.h"

void kernel_main(void) {
    terminal_initialize();
    gdt_install();
    idt_install();
    pic_remap(0x20, 0x28);
    pit_set_frequency(1000);
    idt_set_gate(32, (uint32_t)pit_handler_asm, 0x08, 0x8E);
    asm volatile("sti");
    terminal_printc("Hello, &ekernel &7World!\n&5Magenta String Example\nThis is a &4red string&7.\n");
    for (int i = 0; i < 30; i++) {
        terminal_printc("&cDead &7");
        terminal_putchar('0' + (i / 10));
        terminal_putchar('0' + (i % 10));
        terminal_printc("\n");
        delay(1000);
    }
}