#include "timer.h"
#include "io.h"

#define PIT_FREQUENCY 1193182
#define PIT_CHANNEL_0 0x40
#define PIT_COMMAND 0x43

volatile uint32_t tick = 0;

void pit_handler() {
    tick++;
    outb(0x20, 0x20);
}

void delay(uint32_t milliseconds) {
    uint32_t end = tick + milliseconds;
    while (tick < end) {
        asm volatile("hlt");
    }
}

void pit_set_frequency(uint32_t frequency) {
    uint32_t divisor = PIT_FREQUENCY / frequency;
    outb(PIT_COMMAND, 0x36);
    outb(PIT_CHANNEL_0, divisor & 0xFF);
    outb(PIT_CHANNEL_0, (divisor >> 8) & 0xFF);
}